#include <windows.h>
#include <commdlg.h>
#include <dlgs.h>
#include "PictureView.h"

HINSTANCE g_hInst;

#pragma argsused
int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow )
{
MSG msg;
if (!InitApplication(hInstance))
return (FALSE);
if (!InitInstance(hInstance, nCmdShow))
return (FALSE);
while (GetMessage(&msg,NULL,0,0))
{
TranslateMessage(&msg);
DispatchMessage(&msg);
}
return (msg.wParam);
}

BOOL InitApplication(HANDLE hInstance)
{
WNDCLASS  wc;
wc.style = 0;
wc.lpfnWndProc = (WNDPROC)MainWndProc;
wc.cbClsExtra = 0;
wc.cbWndExtra = 0;
wc.hInstance = hInstance;
wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
wc.hCursor = LoadCursor(NULL, IDC_ARROW);
wc.hbrBackground = GetStockObject(WHITE_BRUSH);
wc.lpszMenuName =  "PictureViewMenu";
wc.lpszClassName = "NViewLinEXWClass";
return (RegisterClass(&wc));
}

BOOL InitInstance( HANDLE hInstance, int nCmdShow)
{
HWND            hWnd;
g_hInst = hInstance;
hWnd = CreateWindow(
        "NViewLinEXWClass",
        "PictureView: NViewLib Borland C++/C Example",
        WS_OVERLAPPEDWINDOW,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        NULL,
        NULL,
        g_hInst,
        NULL
    );

if (!hWnd) return (FALSE);
ShowWindow(hWnd, nCmdShow);
UpdateWindow(hWnd);
return (TRUE);
}

LONG APIENTRY MainWndProc( HWND hWnd, UINT message, UINT wParam, LONG lParam)
{
PAINTSTRUCT ps;
switch (message) {
case WM_CREATE:
break;
case WM_SIZE:
return 0;
case WM_COMMAND:
switch( LOWORD( wParam ))
{
case IDM_FILEOPEN:
OpenTheFile(hWnd);
break;
case IDM_EXIT:
PostQuitMessage(0);
break;
case IDM_ABOUT:
DialogBox(g_hInst,MAKEINTRESOURCE(IDD_ABOUT),hWnd,(DLGPROC)About);
break;
default:
return (DefWindowProc(hWnd, message, wParam, lParam));
}
break;
case WM_DESTROY:
PostQuitMessage(0);
break;
//case WM_PAINT:
//BeginPaint(hWnd,&ps);
//EndPaint(hWnd,&ps);
//break;
default:
return (DefWindowProc(hWnd, message, wParam, lParam));
}
return (0);
}

BOOL OpenTheFile(HWND hWnd)
{
HINSTANCE hInst;
HDC hDC, hDCMemory;
HBITMAP hBitmap, hOldBitmap;
BITMAP bitmap;
OPENFILENAME OpenFileName;
TCHAR         szFile[MAX_PATH]      = "\0";
char *lpBufPtr;
static char * szFilter[]={
"Image Files", "*.jpg;*.jif;*.gif;*.bmp;*.rle;*.dib;*.tga;*.pcx",
"Jpeg Files (*.jpg)", "*.jpg",
"JIF Files (*.jif)", "*.jif",
"GIF Files (*.gif)", "*.gif",
"Bitmap Files (*.bmp)", "*.bmp",
"RLE Files (*.rle)", "*.rle",
"DIB Files (*.dib)", "*.dib",
"TGA Files (*.tga)", "*.tga",
"PCX Files (*.pcx)", "*.pcx",
""};
strcpy( szFile, "");
OpenFileName.lStructSize       = sizeof(OPENFILENAME);
OpenFileName.hwndOwner         = hWnd;
OpenFileName.hInstance         = g_hInst;
OpenFileName.lpstrFilter       = szFilter[0];
OpenFileName.lpstrCustomFilter = NULL;
OpenFileName.nMaxCustFilter    = 0;
OpenFileName.nFilterIndex      = 0;
OpenFileName.lpstrFile         = szFile;
OpenFileName.nMaxFile          = sizeof(szFile);
OpenFileName.lpstrFileTitle    = NULL;
OpenFileName.nMaxFileTitle     = 0;
OpenFileName.lpstrInitialDir   = NULL;
OpenFileName.lpstrTitle        = "Open...";
OpenFileName.nFileOffset       = 0;
OpenFileName.nFileExtension    = 0;
OpenFileName.lpstrDefExt       = NULL;
OpenFileName.Flags             = OFN_SHOWHELP | OFN_EXPLORER ;

if (GetOpenFileName(&OpenFileName))
{
RedrawWindow(hWnd, NULL,NULL, RDW_ERASE|RDW_INVALIDATE);
hBitmap =  NViewLibLoad((char*)OpenFileName.lpstrFile, TRUE);
GetObject(hBitmap, sizeof(BITMAP), &bitmap);
hDC = GetDC(hWnd);
hDCMemory = CreateCompatibleDC(hDC);
hOldBitmap = SelectObject(hDCMemory,hBitmap);
StretchBlt(hDC, 0, 0, bitmap.bmWidth, bitmap.bmHeight, hDCMemory, 0, 0, bitmap.bmWidth, bitmap.bmHeight,SRCCOPY);
SelectObject(hDCMemory, hOldBitmap);
DeleteDC(hDCMemory);
ReleaseDC(hWnd, hDC);

return TRUE;
}
else
{
return FALSE;
}
}

#pragma argsused
BOOL APIENTRY About( HWND hDlg, UINT message, UINT wParam, LONG lParam)
{
switch (message)
{
case WM_INITDIALOG:
return (TRUE);
case WM_COMMAND:
if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
{
EndDialog(hDlg, TRUE);
return TRUE;
}
break;
}
return FALSE;
}


